// GoGoDlg.h : header file
//

#include <afxsock.h>
#include <afxmt.h>
#include "netset.h"
#include "setmask.h"
#include "setgateway.h"
#include "comset.h"


#if !defined(AFX_GOGODLG_H__9E9DAB47_066E_11D5_A375_0080AD918027__INCLUDED_)
#define AFX_GOGODLG_H__9E9DAB47_066E_11D5_A375_0080AD918027__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CGoGoDlg dialog


class CGoGoDlg : public CDialog
{
// Construction
public:
	short m_is8000;
	int m_port_io;
	int m_port_count;
	int YenClearStatus();
	int YenModifyFormat(CString* str);
	int SendReceiveCmd(char* cmd,char* response,ULONG timeout);
	int Get7188EStatus();
	void ResetPortCombo();
	void AddPortSelect();
	void ShowError();
	BOOL bStopThread;
	BOOL bConnect;
	CWinThread* m_readsock;

	CAsyncSocket sockIO;
	CAsyncSocket sock;
	CAsyncSocket sock1;
	CAsyncSocket sock2;
	CAsyncSocket sock3;
	CAsyncSocket sock4;
	CAsyncSocket sock5;
	CAsyncSocket sock6;
	CAsyncSocket sock7;
	CAsyncSocket sock8;
	CAsyncSocket sock9;
	CAsyncSocket sock10;
	CAsyncSocket sock11;
	CAsyncSocket sock12;

	CGoGoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CGoGoDlg)
	enum { IDD = IDD_GOGO_DIALOG };
	CButton	m_btnSend;
	CButton	m_connect;
	CButton	m_disconnect;
	CString	m_status;
	CString	m_send;
	CString	m_send_hex;
	CString	m_receive;
	CString	m_receive_hex;
	int		m_term;
	CString	m_send_cmd;
	CString	m_send_cmd_ack;
	int		m_port_no;
	CString	m_com_status;
	CString	m_gateway;
	CString	m_mac;
	CString	m_mask;
	CString	m_fw_ver;
	CString	m_os_ver;
	CString	m_ip;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGoGoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CGoGoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnChangeSend();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnChangereceive();
	afx_msg void OnResetReceive();
	afx_msg void OnBSend();
	afx_msg void OnSelchangeComboPort();
	afx_msg void OnBNetSet();
	afx_msg void OnBComSet();
	afx_msg void OnBSetGateway();
	afx_msg void OnBSetMask();
	afx_msg void OnCloseBtn();
	afx_msg void OnbtnSendCmd();
	afx_msg void OnbtnClearCmd();
	afx_msg void OnbtnConnect();
	afx_msg void OnbtnDisconnect();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

typedef struct tagTHREADPARMS{
	int hello;
	LPARAM lParam;
}THREADPARMS;

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GOGODLG_H__9E9DAB47_066E_11D5_A375_0080AD918027__INCLUDED_)
